
c simple little program to construct phi.file for the 
c kortshagen, parker, lawler pc paper...

c there's a slight problem, since the potential is continous 
c but Er is discontinous. the mc uses fields at edges of 
c cells and is continous. the field is calculated by taking 
c the numerical derivative of the potential (at cell centers).
c so, use the correct field up to and including the inner boundary
c of the last cell and then find the field at the outer boundary 
c such that integrating the field across the last cell give the 
c correct voltage chage: Vw - Vsh

	real v(0:26)

c input...
	nz = 15		!number of axial  cells
	nr = 25			!number of radial cells
	z_max = 450.	!L (cm)
	r_max = 1.		!R (cm)
	Ez  = -1.02	!V/cm  axial field
	vsh = 8.	!V   sheath potential (V at r = 24 R / 25)

c program...
	vw  = vsh*(nr/max(1.,nr-1.))**2	!V   wall potential   (V at R*(nr-1)/nr
	dr  = r_max / nr
	dz  = z_max / nz
	VEz = - Ez * dz   !axial potential change across one cel

c inner cells...
	b  = vsh / (max(nr-1.,1.) * dr)**2

	v(0) = 0.
	v(1) = 0.
	do i = 2, nr+1
	  v(i) = b * (dr * (i-0.5) )**2
	enddo

	open(10,file='phi.out')
	 write(10,"(a)") 'phifile:'
	 write(10,"('nr=',i3,' nz=',i3,' R=',1p,e13.5,' Z=',e13.5)")
     ^	   nr,nz,r_max,z_max
	 write(10,"(1p,'Vsh=',e13.5,' Vw=',e13.5, ' Ez=',e13.5)")
     ^	   vsh,vw,ez
	 write(10,*)
	 write(10,"(a)") '>>>>>>'
	 do j = 0, nz+1    !do j = 0, nz_mc+1
	   write(10,"(1p,700e13.5)") (-Vez*j-v(i),i=0,nr+1)
	 enddo
	close(10)

	open(10,file='ez.out')
	 write(10,"(a)") 'ezfile:'
	 write(10,"('nr=',i3,' nz=',i3,' R=',1p,e13.5,' Z=',e13.5)")
     ^	   nr,nz,r_max,z_max
	 write(10,"(1p,'Vsh=',e13.5,' Vw=',e13.5, ' Ez=',e13.5)")
     ^	   vsh,vw,ez
	 write(10,*)
	 write(10,"(a)") '>>>>>>'
	 do j = 0, nz
	   write(10,"(1p,700e13.5)") (ez,i=0,nr)
	 enddo
	close(10)

	b = 2. * b
	open(10,file='erx.out')
	 write(10,"(a)") 'erxfile:'
	 write(10,"('nr=',i3,' nz=',i3,' R=',1p,e13.5,' Z=',e13.5)")
     ^	   nr,nz,r_max,z_max
	 write(10,"(1p,'Vsh=',e13.5,' Vw=',e13.5, ' Ez=',e13.5)")
     ^	   vsh,vw,ez
	 write(10,*)
	 write(10,"(a)") '>>>>>>'
	 do j = 0, nz
	   write(10,"(1p,700e13.5)") (b*i*dr,i=0,nr)
	 enddo
	close(10)


	end
