
	integer nr,nz,nq
	parameter (nr=25,nz=15,nq=3)

	real gg(0:nr+1,0:nz+1)
	real dd(nr,nz)
	real tt(nr,nz)
	real rr(nr,nz,nq),nn,mn,tn
	real x1,x2,x3
	real*8 y1,y2,y3


	write(*,"('neutral density (1/cc) [0 -> 3e16]?')")
	read *, nn
	if (nn.le.0.0) nn=3.e16
	write(*,"('neutral density =',1p,e12.5,' (1/cc)')") nn
	write(*,*)

	write(*,"('neutral temperature (K) [0 -> 300]?')")
	read *, tn
	if (tn.le.0.0) tn=300.
	write(*,"('neutral temperature =',1p,e12.5,' (K)')") tn
	write(*,*)

	write(*,"('neutral mass (amu) [0 -> 39.948]?')")
	read *, mn
	if (mn.le.0.0) mn = 39.948
	write(*,"('neutral mass =',1p,e12.5,' (amu)')") mn
	write(*,*)

	x2 = ( 0.01 / 2.405 ) ** 2
	x1 = sqrt( tn / mn ) * 145.50764 * nn * 40.e-14
	x2 = 64323054.7 / mn / x2

	open(55,file='gain.k')
	  read(55,*) ((gg(i,j),i=0,nr+1),j=nz+1,0,-1)
	close(55)

	open(55,file='energy.k')
	  read(55,*) ((tt(i,j),i=1,nr),j=nz,1,-1)
	close(55)

	open(55,file='tt.k')
	  read(55,*) ((dd(i,j),i=1,nr),j=nz,1,-1)
	close(55)

	open(55,file='v_sigma.k')
	  read(55,*) (((rr(i,j,k),i=1,nr),j=nz,1,-1),k=1,nq)
	close(55)

	write(*,"('r     source-loss    (source-loss)/|loss|',
     ^		'      source              loss           ',
     ^          '    D/G^2          <n v_ion>/<n>  ',
     ^          '     frac error')")
	 do j = nz+1, 0, -1
	  x = 0.
	  y = 0.
	  z = 0.
	  do i = 0, nr+1
	    x = x + gg(i,j)
	    if (gg(i,j) .gt. 0.0) then
	      y = y + gg(i,j)
	    else
	      z = z - gg(i,j)
	    endif
	  enddo

	  y3 = 0.d0
	  x3 = 0.d0
	  if (j.gt.0.and.j.lt.nz+1) then
	    y1 = 0.d0
	    y2 = 0.d0
	    do i = 1, nr
	      y1 = y1 + dd(i,j)
	      y2 = y2 + dd(i,j) * rr(i,j,nq)
	    enddo
	    y2 = y2 * nn
	    if (y1 .ne. 0.d0) y1 = 1.d0 / y1
	    y3 = y2 * y1
	    x3 = x2 * tt(1,j)
	  endif
c	  write(*,*) x1,x3,y3,y1,y2,x1,x2,x3/(x1+2.*y3),y3
	  x3 = x3 / (x1 + 2. * y3)

	  write(*,"(i3,1p,e16.8,6(3x,e16.8))") 
     ^		j,x,x/(abs(gg(nr+1,j))+11.e-22),y,z,
     ^		x3,y3,(x3-y3)/(max(x3,real(y3))+1.e-22)
	enddo
        end
