 
 
 
 
c mesh constants:
	integer nrmax_mc,nzmax_mc,inspec_mc
c	parameter(nrmax_mc=107,nzmax_mc=40,inspec_mc=3)
c	parameter(nrmax_mc=78,nzmax_mc=30,inspec_mc=5)
c	parameter(nrmax_mc=60,nzmax_mc=42,inspec_mc=5)
c	parameter(nrmax_mc=2,nzmax_mc=205,inspec_mc=5)
 	parameter(nrmax_mc=30,nzmax_mc=50,inspec_mc=5)
	integer nq_max_mc
c	parameter(nq_max_mc=9)
	parameter(nq_max_mc=20)
	integer it1_mc
	parameter(it1_mc=1)
	integer ntmax_mc,ntnmax_mc
c	parameter(ntmax_mc=7,ntnmax_mc=220)
 	parameter(ntmax_mc=3,ntnmax_mc=98)
 
c     nrmax_mc = maximum radial cells
c     nzmax_mc = maximum axial (z) cells
c    inspec_mc = NSP = maxium number of different chemical species
c    nq_max_mc = maxium number of cross sections
c       it1_mc = maxium number of time slices
c     ntmax_mc = maxium number of emitting surfaces
c    ntnmax_mc = maxium number of emitting cells
 
c-------------------------------------------------------------------
 
 
	real*8 ave_unconf_t_mc
	real*4
     1	  gps_mc(it1_mc,nrmax_mc,nzmax_mc,nq_max_mc,-2:ntmax_mc),
     2	  gpnu_mc(it1_mc,nrmax_mc,nzmax_mc),
     3    gpne_mc(it1_mc,nrmax_mc,nzmax_mc),
     4    tot_ion_out_mc, t_run_mc, t_mc
	real qvol_mc(inspec_mc+1)
	real gpmb_mc(nrmax_mc,nzmax_mc)
	real gpdf_mc(nrmax_mc,nzmax_mc)
	logical df_mb_mc
 
	common /mc1_0_com/ ave_unconf_t_mc,
     1	       gps_mc,gpnu_mc,gpne_mc,tot_ion_out_mc, t_run_mc,t_mc,
     2		qvol_mc,gpmb_mc,gpdf_mc,df_mb_mc
 
 
c gps_mc(t,r,z,i) = rate constant of collision i at (t,r,z) (cm^3/s)
c gpnu_mc(t,r,z) = collision frequency at (t,r,z) (1/s)
c gpne_mc(t,r,z) = electron density normalized to total number of electrons
c                in discharge at (t,r,z) (1/cm^3)
 
	real*4 n_density_mc(it1_mc,nrmax_mc,nzmax_mc,inspec_mc)
c	real*4 n_density_mc(1,nrmax_mc,nzmax_mc,inspec_mc)
     2       , e_density_mc(it1_mc,nrmax_mc,nzmax_mc)
     3       , t_electron_mc(it1_mc,nrmax_mc,nzmax_mc)
     4       , rt_mc(nrmax_mc+1), rcm_mc(nrmax_mc) , delta_r_mc
     5       , zt_mc(nzmax_mc+1), zcm_mc(nzmax_mc) , delta_z_mc
        integer nr_mc, nz_mc, nspec_mc
	real*8 ele_s_mc(0:nrmax_mc+1,0:nzmax_mc+1),ele_s_max_mc
	real*8 ele_s_e_mc(nrmax_mc,nzmax_mc)
	integer ele_nl_mc(nrmax_mc,nzmax_mc)
	real delta_ri_mc,delta_zi_mc,delta_ei
	real  dr_mc(0:nrmax_mc+1), dz_mc(0:nzmax_mc+1)
	real dri_mc(0:nrmax_mc+1),dzi_mc(0:nzmax_mc+1)
 
	common /mc1_1_com/ ele_s_mc,ele_s_e_mc,ele_s_max_mc,
     1         n_density_mc,dr_mc,dz_mc,dri_mc,dzi_mc
     2       , e_density_mc
     3       , t_electron_mc
     4       , rt_mc , rcm_mc , delta_r_mc, delta_ri_mc
     5       , zt_mc , zcm_mc , delta_z_mc, delta_zi_mc, delta_ei
     6       , nr_mc, nz_mc, nspec_mc, ele_nl_mc
 
 
c n_density_mc(t,r,z,i) = density of species i at (t,r,z) (1/cm^3)
c e_density_mc(t,r,z) = density of electrons at (t,r,z) (1/cm^3)
c t_electron_mc(t,r,z) = guess of electron temperature at (t,r,z) (eV)
c rt_mc(r) = radial position of 'inside' of radial cell (cm)
c rcm_mc(r) = radial position of center of radial cell (cm)
c delta_r_mc = spacing in radius if uniform, or average spacing if not uniform
c zt_mc(z) = axial position of 'bottom' of axial cell (cm)
c zcm_mc(z) = axial position of center of axial cell (cm)
c delta_z_mc = spacing in axial if uniform, or average spacing if not uniform
c Nr_mc = maxium radial index of plasma region
c Nz_mc = maxium axial index of plasma region
c nspec_mc = number of non-electron species...
 
	real*4  rf_freq_mc,rf_period_mc,omega0_mc
	integer run_type_mc
	logical lcyl_mc,inductp_mc,static_b_p_mc
 
	common /mc1_2_com/ rf_freq_mc,rf_period_mc,omega0_mc,
     ^	  run_type_mc,lcyl_mc,inductp_mc,static_b_p_mc
 
c rf_freq_mc = inductive coil driving frequency (cycle/s)
c rf_period_mc = 1/rf_freq (s)
c omega0_mc = 2 pi rf_freq = driving frequency for inductive fields (rad/s)
 
	real*4 r_max_mc,z_min_mc,z_max_mc,
     1     sheath_potential_mc(0:nrmax_mc+1,0:nzmax_mc+1)
        integer  mask_mc(0:nrmax_mc+1,0:nzmax_mc+1)
 
	common /mc1_3_com/ r_max_mc, z_min_mc, z_max_mc,
     1     sheath_potential_mc,
     2     mask_mc
 
c r_max_mc = maxium radius (cm)
c z_min_mc = minium axial height (cm)
c z_max_mc = maxium axial height (cm)
c sheath_potential_mc(r,z) = extra (ie beyond fields) voltage electron
c         must overcome at (r,z) to escape system (V) [typically = 0.0 V]
c mask(r,z)_mc = mask. 0 if plasma, otherwise NOT plasma
 
 
	complex*8 e_theta_mc(0:nrmax_mc,0:nzmax_mc),
     1	  b_r_mc(0:nrmax_mc,0:nzmax_mc),b_z_mc(0:nrmax_mc,0:nzmax_mc),
     2    b_th_mc(0:nrmax_mc,0:nzmax_mc)
	complex*8
     1	  e_r_mc(0:nrmax_mc,0:nzmax_mc),e_z_mc(0:nrmax_mc,0:nzmax_mc)
	real*4
     2     epl_r_mc( 0:nrmax_mc,0:nzmax_mc,it1_mc)
     3   , epl_z_mc( 0:nrmax_mc,0:nzmax_mc,it1_mc)
     4   , bpl_r_mc( 0:nrmax_mc,0:nzmax_mc)
     5   , bpl_z_mc( 0:nrmax_mc,0:nzmax_mc) , ef0d
     6   , bpl_th_mc(0:nrmax_mc,0:nzmax_mc)
	real phi_pl_mc(0:nrmax_mc+1,0:nzmax_mc+1,it1_mc)
 
	common /mc1_4_com/
     1     e_theta_mc, b_r_mc, b_z_mc, e_r_mc, e_z_mc, b_th_mc
     2   , epl_r_mc
     3   , epl_z_mc
     4   , bpl_r_mc, bpl_th_mc
     5   , bpl_z_mc,phi_pl_mc, ef0d
 
c E_theta_mc(r,z) = complex E in azimuthal direction at (r,z) (V/cm)
c B_r_mc(r,z) = complex B in radial direction at (r,z) (guass/1e8)
c B_z_mc(r,z) = complex B in axial direction at (r,z) (guass/1e8)
c   [ the real part of these fields * exp (-i omega0 t) are the fields]
c Epl_r_mc(t,r,z) = 'static' E field in the radial direction at (t,r,z) (V/cm)
c Epl_z_mc(t,r,z) = 'static' E field in the axial direction at (t,r,z) (V/cm)
c Bpl_r_mc(r,z) = 'static' B field in the radial direction at (r,z) (guass/1e8)
c Bpl_z_mc(r,z) = 'static' B field in the axial direction at (r,z) (guass/1e8)
 
	real nt_f_mc(0:ntmax_mc),ntn_fm_mc(0:ntmax_mc)
	real ntn_f_mc(ntnmax_mc),ntn_fe_mc(ntnmax_mc)
	integer ntd_mc(7,ntnmax_mc),ntsn_mc(2,ntmax_mc)
	integer nt_mc,ntn_mc
 
	common / mc1_5_1_com / nt_f_mc,ntn_fm_mc,ntn_f_mc,
     ^	  ntn_fe_mc,ntd_mc,ntsn_mc,nt_mc,ntn_mc
 
 
 
        character*80 raten_fl_mc(nq_max_mc),specn_mc(inspec_mc)
	common / mc1_5_com / raten_fl_mc,specn_mc
 
c raten_fl_mc(reaction #) = string describing fluid reaction
c specn_mc(i) = string describing ith species
 
 
	integer cross_mc(nq_max_mc),ic_mc(nq_max_mc),nqi_mc
	common / mc1_6_com/ cross_mc,ic_mc,nqi_mc
 
c cross_mc(collision #) = reaction # of fluid reactions
c ic_mc(collision #) = species index for collision partner
c nqi_mc = number of electron collisions = number of electron reactions
 
	integer it1_max_mc
	real*4 ph1_t_max_mc,ph1_t_min_mc,ph1_v_mc(0:it1_mc)
	common / mc1_7_com / ph1_t_max_mc,ph1_t_min_mc,
     ^	    ph1_v_mc,it1_max_mc
 
 
	logical see_p_mc
	integer see_i_mc
	parameter (see_i_mc=5)
	integer see_mask_mc(see_i_mc),see_nmask_mc
	real see_e0m_mc(see_i_mc),see_dm_mc(see_i_mc)
	real see_wf_mc(see_i_mc)
	real see_surfq_mc(0:nrmax_mc+1,0:nzmax_mc+1)
     	real see_wgt_mc(0:ntmax_mc),see_min_mu_mc
 
	common / mc1_8_com /
     ^		see_surfq_mc, see_wf_mc, see_wgt_mc,
     ^		see_e0m_mc, see_dm_mc, see_min_mu_mc,
     ^		see_mask_mc, see_nmask_mc,
     ^		see_p_mc
