 
c mesh constants:
	integer n_e
	parameter(n_e=350)
 
c cross section constants:
	integer npts,inedcs,inadcs
	parameter (npts=215)
c	parameter (npts=120)
	parameter (inedcs=34,inadcs=17)
c	parameter (inedcs=3 ,inadcs=2)
 
	integer indx_e_max
c	parameter(indx_e_max=(nrmax_mc+2)*
c     ^		    (nzmax_mc+2)*(ntmax_mc+2)/2)
	parameter(indx_e_max=(nrmax_mc+2)*
     ^		    (nzmax_mc+2)*(ntmax_mc+2))
 
c       n_e = number of energy cells for EEDF
c      NPTS = maximum number of points for cross sections
c    iNeDCS = maximum number of energy DCS points
c    iNADCS = maximum number of angles in DCS
 
 
c physical and other constants:
	real*4 pi,q0,emass,emassamu,ergev,ejev,bk1,ryd
c	parameter (Pi = acos(-1.e0))
	parameter (pi = 3.14159265359e0)
	parameter (q0 = 1.0e-16)         ! conversion: 1 A^2 = 10^-16 cm^2
	parameter (emass = 9.10956e-28)  ! electron mass in gm
	parameter (emassamu = 5.446e-4)  !    "      "   "  amu
	parameter (ergev = 1.602192e-12) ! ergs/eV
	parameter (ejev = 1.602192e-19)  ! Joules/eV
	parameter (bk1 = 8.6169e-5)      ! Boltzmann's const in eV / deg. K
	parameter (a0 = 0.529e-8)        ! Bohr radius in cm
	parameter (ryd = 13.6048)        ! Rydberg constant in eV
 
 
 
c-----------------------------------------------------------------
 
 
	integer nfe,izfe(nzmax_mc*nrmax_mc),irfe(nzmax_mc*nrmax_mc)
	integer push_order
	real*4 zfe(nzmax_mc*nrmax_mc),rfe(nrmax_mc*nzmax_mc)
	logical trp_max_p,harmonic_p,ext_max_p,ion_equal_e_p
	real*4 trp_max_te,del_xt,del_bf
	logical full_eedf_p,accum_t_p
	integer nmu_mc, nphi_mc
	real*4 dmu_mc, dphi_mc, dimu_mc, diphi_mc
	common /cmb_000fe/ rfe,zfe,trp_max_te,del_xt,del_bf,
     ^		dmu_mc, dphi_mc, dimu_mc, diphi_mc,
     ^		nfe, izfe, irfe, push_order, nmu_mc, nphi_mc,
     ^		trp_max_p, harmonic_p,
     ^		ext_max_p, ion_equal_e_p, full_eedf_p, accum_t_p
 
 
	real fe_last(n_e,nrmax_mc,nzmax_mc)
	real fe_lastt(nrmax_mc,nzmax_mc), fe_lastmx
	real fe_last_ee
	logical fe_last_p, trapped_p, secondary_p
 
	common /cmb_00a/ fe_last, fe_lastt, fe_lastmx,
     ^		fe_last_ee, fe_last_p, trapped_p, secondary_p
 
 
	character*40 coll_p_name(nq_max_mc)
	common /cmb_00/ coll_p_name
 
	integer spec_t
	real spec_tm,spec_tq
	real*8 ing_coeff(0:8+nq_max_mc)
	common /cmb_001/ ing_coeff, spec_tm, spec_tq, spec_t
 
 
	real*4 nmax(inspec_mc),nave(inspec_mc),
     ^	  vol_cell(nrmax_mc,nzmax_mc),vol_total,
     ^    a_r(nrmax_mc+1,nzmax_mc),a_z(nrmax_mc+1)
	real min_energy
	integer ele_trapped(nrmax_mc,nzmax_mc)
	common /cmb_1/
     1         nmax     , nave
     2       , vol_cell , vol_total
     3       , a_r      , a_z , min_energy, ele_trapped
 
c nmax(i) = maximum density of species i on mesh (1/cm^3)
c nave(i) = spatial averaged density of species i (1/cm^3)
c vol_cell(r,z) = volume of cell at (r,z) (cm^3)
c vol_tot = total volume of on mesh (sum of vol_cell(r,z))
c a_r(r,z) = area of radial face at rt (cm^2)
c a_z(r) = area of axial face (cm^2)
 
	real t_max_region(-1:ntmax_mc),t_min_region(-1:ntmax_mc)
	integer n_traj_region(-1:ntmax_mc),n_cold(-1:ntmax_mc)
	integer n_collisions_region(nq_max_mc,-1:ntmax_mc)
	real weight_reg(-1:ntmax_mc),weight_mx, te0
	real*8 w_d(-1:ntmax_mc), w_d_sc
 
	common /stupcom/ w_d, w_d_sc,
     ^	  t_max_region, t_min_region,weight_reg,
     ^	  weight_mx,te0,
     ^	  n_traj_region,n_cold,n_collisions_region
 
 
	integer indx_e(0:nrmax_mc+1,0:nzmax_mc+1,-1:ntmax_mc)
	real*4 tn_of_e_rz(it1_mc,n_e,0:indx_e_max)
c	real*4 tN_of_e_rz(it1_mc,N_e,0:nrmax_mc+1,
c     ^		           0:nzmax_mc+1,-1:ntmax_mc)
	real*4 ne(it1_mc,nrmax_mc,nzmax_mc)
	real*4 ne_max(it1_mc),max_coll_freq
	real*4 f_of_e(n_e),delta_e
	real*4 ee_max
	real e_bar_rz(it1_mc,nrmax_mc,nzmax_mc,-1:ntmax_mc)
	real*4 e_energy(n_e)
 
	real*8 v_ave(3,0:nrmax_mc+1,0:nzmax_mc+1,-1:ntmax_mc)
	real*8 pow_t(0:nrmax_mc+1,0:nzmax_mc+1,-2:ntmax_mc)
	real*8 pow_tt,pow_tn
 
	common /e_distribution/ tn_of_e_rz , v_ave, pow_t,
     1		 pow_tt  , pow_tn  ,
     1		 ne      , ne_max  ,
     2           f_of_e  , delta_e , ee_max,
     3           e_bar_rz, e_energy,
     4		 max_coll_freq, indx_e
 
c tn_of_e_rz(e,r,z) = `eedf' at (r,z) (#)
c ne(r,z) = # of electrons at (r,z) (#)
c ne_max = maxium electron density on mesh (1/cm^3)
c f_of_e(e) = global `eedf' (#)
c delta_e = spacing in energy for eedfs (eV)
c ee_max = max energy for eedf (maxium energy for cross section in Q_dcs_data)
c e_bar = global average electron energy (eV)
c e_bar_rz(r,z) = local electron energy (eV)
c e_energy(e) = energy mesh for eedf (eV)
c max_coll_freq = maxium collision frequency (1/s)
 
	integer*4 total_time_steps, ave_steps, n_traj
	real*4 nsteps_rz(it1_mc,nrmax_mc,nzmax_mc,-1:ntmax_mc)
	real   m_ave_time
	real*8 ave_time
	real*8 pow_c(0:nrmax_mc+1,0:nzmax_mc+1,-2:ntmax_mc),pow_ct
	real*8 pow_i(0:nrmax_mc+1,0:nzmax_mc+1,-2:ntmax_mc),pow_it
	real*8 pow_x(0:nrmax_mc+1,0:nzmax_mc+1,-2:ntmax_mc),pow_xt
	real*8 pow_tr,pow_cr,pow_ir,pow_xr,pow_xn
	real*8 e_bar,total_time
	real*4 t_min,t_max,delta_t
 
	common /run_params/ ave_time,pow_tr,pow_cr,pow_ir,pow_xr,
     1                    pow_c,pow_ct,
     2                    pow_i,pow_it,
     2                    pow_x,pow_xt,pow_xn,
     3                    total_time,e_bar,
     4			  t_min,t_max,delta_t,
     5                    nsteps_rz,m_ave_time,
     6                    total_time_steps,ave_steps,n_traj
 
c t_min = minium time to run an electron before recording data
c t_max = maxium time to follow any one electron (s)
c delta_t = minium collision time = 1/max_coll_freq (s)
c total_time = sum of recorded time for all electrons
c ave_time = average time spent on each electron (s)
c n_traj = number of electrons followed and tracked
c total_time_stpes = total number of time steps (#)
c ave_steps = average # of steps per trajectory (#)
c nsteps_rz = total time spent in cell (r,z) (s)
c avr(r,z) = average Vr at (r,z) (cm/s)
c avth(r,z) = average Vtheta at (r,z) (cm/s)
c avz(r,z) = average Vz at (r,z) (cm/s)
c pow_rz(r,z) = power via Eth at (r,z) (W/s)
c m_ave_time = in input: average time per electron to simulate (s)
c            = in code: scaled up by nr * nz
 
	real*4 sheath_potential0
	real n_loss(0:nrmax_mc+1,0:nzmax_mc+1)
	real n_gain(0:nrmax_mc+1,0:nzmax_mc+1)
	integer no_loss(2,-1:ntmax_mc)
	real   ne_loss(nrmax_mc,nzmax_mc), ne_loss_av, ne_loss_tot
	common /cboundaries/ sheath_potential0,ne_loss,n_loss,
     ^		n_gain,ne_loss_av, ne_loss_tot, no_loss
 
c sheath_potential0 = if on input not = 0, sheath_potential(r,z) = this (V)
c n_loss(r,z) = # of electrons lost at (r,z) (#)
 
	logical b_fieldsp,dumpfile_p
 
	common /eb_fields/ b_fieldsp,dumpfile_p
c b_fieldsp = .true.  --> use B_r, B_z, Bpl_r and Bpl_z
c           = .false. --> do NOT use B_r, B_z, Bpl_r and Bpl_z (ie B = 0)
 
	real*8 mfp_per_step
	real*4 f_elastic,f_inelastic,coll_prob_max
	integer n_elastic,n_inelastic,n_coll_r,n_coll_zmin
	integer n_coll_zmax,n_e_lost,n_attach,n_ion
	integer ic0(nq_max_mc)
	common /transport_coeffs/  mfp_per_step,
     1		   f_elastic, f_inelastic, coll_prob_max
     2                        , n_elastic, n_inelastic
     3                        , n_coll_r , n_coll_zmin, n_coll_zmax
     4                        , n_e_lost , n_attach   , n_ion, ic0
 
 
c f_elastic = elastic collision rate (1/s)
c f_inelastic = inelastic collision rate (1/s)
c coll_prob_max = - ln(1-maxium collision probability)
c N_elastic = total number of elastic collisions (#)
c N_inelastic = total number of inelastic collisions (#)
c mfp_per_step = average length travelled per time step (cm)
c n_coll_r = number of 'bounces' off a radial surface (#)
c n_coll_zmin = number of 'bounces' off a lower axial surface (#)
c n_coll_zmax = number of 'bounces' off an upper axial surface (#)
c n_e_lost = # of electrons lost through a boundary (#)
c N_attach = # of electrons lost via attatchment (#)
c N_ion = # of ionization events (#)
 
 
	character*100 q_tot_data, q_dcs_data
	character*8  run_label
	integer l_label
 
	common /file_names/ l_label,  q_tot_data, q_dcs_data,
     1                    run_label
 
c L_label = number of non-blank characters in string Run_label
c Q_tot_data = file name of total cross section file
c Q_dcs_data = file name of species list and differential elastic cross section
c run_label = file name of output files
 
	character*80 rate_in(nq_max_mc)
 
	common /cross_names_com/ rate_in
 
c rate_in(i) = string describing the ith cross section
 
 
 
 
c*--------------------------------------------------------------------72
 
      integer ncomp
      real*4 e_cs(0:npts,nq_max_mc),q_cs(0:npts,nq_max_mc)
      real*4 qe_cs(0:npts,nq_max_mc)
 
 
      common /c1/ e_cs,q_cs,qe_cs,ncomp
 
c ncomp = number of colliding partners =< nspec
c e_cs(i,q) = energy point i for qth collision
c q_cs(i,q) = x section value i for qth collision
 
 
 
c following common is for differential cross section.
	real*4 edcs(0:inedcs,nq_max_mc),adcs(inadcs,nq_max_mc)
	integer nedcs(nq_max_mc),nadcs(nq_max_mc)
	real*4 qdcs(inadcs,0:inedcs,nq_max_mc),dcs_beta(nq_max_mc)
	logical dcs_flag(nq_max_mc)
	common /cdcs/ edcs,adcs,qdcs,dcs_beta,nedcs,nadcs,dcs_flag
 
c edcs(i,q) = ith energy point for qth collision for dcs
c adcs(j,q) = jth angle point  for qth collision for dcs
c nedcs(q)  = number of energy points for qth collision
c nadcs(q)  = number of angle  points for qth collision
c qdcs(j,i,q) = d sigma / d theta at angle j, energy i, qth collision
c dcs_flag(q) = true -> dcs for this collision
c dcs_beta(q) = beta, if 0 < beta < 1, then f(mu) ~ 1 - alpha mu,
c            s.t. beta = <V> / V, ie average cos of the angle
c            scattered...
 
 
      character*40  name_cs(nq_max_mc)
 
      common /clogo/  name_cs
 
c name_cs(q) = name of colliding partner
 
	real*8 e_min,e_max
        real*4 sigma(nq_max_mc),
     1	  energy_loss(nq_max_mc),
     2    a_mass(nq_max_mc), coll_freq(nq_max_mc)
        integer iq_flag(nq_max_mc),n_collisions(nq_max_mc),
     1    nq,n_coll_rz(nq_max_mc,nrmax_mc,nzmax_mc)
	integer npts_cs(nq_max_mc)
 
      common /q_stuff/ e_min,e_max,sigma,
     1	  energy_loss,
     2    a_mass, coll_freq,
     3	  n_collisions,
     5    iq_flag, nq,
     6    n_coll_rz,npts_cs
 
c e_min = not used
c e_max = maxium energy electrons are record to
c sigma(q) = cross section for collision q for a given energy
c energy_loss(q) = dE for qth collision.  > 0 --> loss
c a_mass(q) = atomic mass of colliding partner
c coll_freq(q) = collision frequency, corresponds to sigma(q)
c iq_flag(q) = collision type:
c              -1: attachment
c               0: momentum transfer (elastic)
c               1: inelastic or superelastic
c               2: ionization
c n_collisions(q) = total number of collisions of q
c nq = number of electron collisions
c n_coll_rz(q,r,iz) = total number of collisions of q at r,z
c npts_cs(q) = number of energy, x section pairs for collision q
 
 
	character*80 raten_in(nq_max_mc)
	common / q_name_comm / raten_in
 
c raten_in(q) = name of cross section process.  better correspond
c               to a fluid rate!
